function Create(self)
	self.UpdateTimer = Timer()
	self.TokenTimer = Timer()

	if not UAV.TrtCtrl then
		UAV.TrtCtrl = {}
	end
	
	if not UAV.TrtCtrl[self.Team] then
		UAV.TrtCtrl[self.Team] = true
		self.inControl = true
	end
	
	if not UAV.Turrets then
		UAV.Turrets = {}
	end
	
	if not UAV.Token then
		UAV.Token = 1
	end
	
	self.timing = 150
end

function Destroy(self)
	UAV.TrtCtrl[self.Team] = false
	if self.inControl then
		UAV.Token = 1
	end
end

function Update(self)
	if self.UpdateTimer:IsPastSimMS(1000) then
		self.UpdateTimer:Reset()
		
		if not UAV.TrtCtrl[self.Team] then
			UAV.TrtCtrl[self.Team] = true
			self.inControl = true
		end
	end
	
	if self.inControl and #UAV.Turrets > 0 and self.TokenTimer:IsPastSimMS(self.timing) then
		self.TokenTimer:Reset()
		
		UAV.Token = UAV.Token + 1
		if UAV.Token > #UAV.Turrets then
			UAV.Token = 0
			if #UAV.Turrets > 1 then
				self.timing = math.ceil((250+(#UAV.Turrets*10)) / #UAV.Turrets)	-- try to update all turrets once every ~250ms
			end
		end
	end
end